package PlayBot::sessions::downloader;

use strict;
use warnings;

use JSON;
use POE;

use PlayBot::utils::Logging;
use PlayBot::sessions::downloader::ddl;

my $log = PlayBot::utils::Logging->new('STDOUT', 1);

local $/;
open CONF, '<', 'playbot.conf';
my $json = <CONF>;
my $conf = decode_json($json);

if ($conf->{download})
{
    POE::Session->create(
        inline_states   => {
            _start          => \&on_start,
            ddl             => \&PlayBot::sessions::downloader::ddl::exec,
            filename        => \&PlayBot::sessions::downloader::ddl::filename,
            signal_filename => \&PlayBot::sessions::downloader::ddl::signal_filename,
            signal_ddl      => \&PlayBot::sessions::downloader::ddl::signal_ddl,
            signal_move     => \&PlayBot::sessions::downloader::ddl::signal_move,
            signal_rm       => \&PlayBot::sessions::downloader::ddl::signal_rm,
            end_task        => \&PlayBot::sessions::downloader::ddl::end_task,
        },
    );
}


sub on_start {
    my ($kernel, $heap) = @_[KERNEL, HEAP];
    $kernel->alias_set('downloader');
    $heap->{ddl}->{tasks} = [];

    $log->info("session started");
}

1;
